<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSubcontractedResultStrategy ArrayType
 * @subpackage Arrays
 */
class ArrayOfSubcontractedResultStrategy extends AbstractStructArrayBase
{
    /**
     * The SubcontractedResultStrategy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SubcontractedResultStrategy[]
     */
    public $SubcontractedResultStrategy;
    /**
     * Constructor method for ArrayOfSubcontractedResultStrategy
     * @uses ArrayOfSubcontractedResultStrategy::setSubcontractedResultStrategy()
     * @param \StructType\SubcontractedResultStrategy[] $subcontractedResultStrategy
     */
    public function __construct(array $subcontractedResultStrategy = array())
    {
        $this
            ->setSubcontractedResultStrategy($subcontractedResultStrategy);
    }
    /**
     * Get SubcontractedResultStrategy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SubcontractedResultStrategy[]|null
     */
    public function getSubcontractedResultStrategy()
    {
        return isset($this->SubcontractedResultStrategy) ? $this->SubcontractedResultStrategy : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSubcontractedResultStrategy method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubcontractedResultStrategy method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubcontractedResultStrategyForArrayConstraintsFromSetSubcontractedResultStrategy(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) {
            // validation for constraint: itemType
            if (!$arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem instanceof \StructType\SubcontractedResultStrategy) {
                $invalidValues[] = is_object($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) ? get_class($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem) : sprintf('%s(%s)', gettype($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem), var_export($arrayOfSubcontractedResultStrategySubcontractedResultStrategyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SubcontractedResultStrategy property can only contain items of type \StructType\SubcontractedResultStrategy, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SubcontractedResultStrategy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SubcontractedResultStrategy[] $subcontractedResultStrategy
     * @return \ArrayType\ArrayOfSubcontractedResultStrategy
     */
    public function setSubcontractedResultStrategy(array $subcontractedResultStrategy = array())
    {
        // validation for constraint: array
        if ('' !== ($subcontractedResultStrategyArrayErrorMessage = self::validateSubcontractedResultStrategyForArrayConstraintsFromSetSubcontractedResultStrategy($subcontractedResultStrategy))) {
            throw new \InvalidArgumentException($subcontractedResultStrategyArrayErrorMessage, __LINE__);
        }
        if (is_null($subcontractedResultStrategy) || (is_array($subcontractedResultStrategy) && empty($subcontractedResultStrategy))) {
            unset($this->SubcontractedResultStrategy);
        } else {
            $this->SubcontractedResultStrategy = $subcontractedResultStrategy;
        }
        return $this;
    }
    /**
     * Add item to SubcontractedResultStrategy value
     * @throws \InvalidArgumentException
     * @param \StructType\SubcontractedResultStrategy $item
     * @return \ArrayType\ArrayOfSubcontractedResultStrategy
     */
    public function addToSubcontractedResultStrategy(\StructType\SubcontractedResultStrategy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubcontractedResultStrategy) {
            throw new \InvalidArgumentException(sprintf('The SubcontractedResultStrategy property can only contain items of type \StructType\SubcontractedResultStrategy, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SubcontractedResultStrategy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SubcontractedResultStrategy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SubcontractedResultStrategy
     */
    public function getAttributeName()
    {
        return 'SubcontractedResultStrategy';
    }
}
